static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0x9F, 0xA5, 0xDC, 0xFE, 0x4D, 0x09, 0xB3, 0xE4, 0x88, 0x72,
        0x94, 0x71, 0xFC, 0xCF, 0x5C, 0xD3, 0x67, 0x56, 0x10, 0x8D,
        0x5B, 0xEB, 0xEA, 0x65, 0xFC, 0x35, 0xE6, 0xA2, 0x8C, 0x80,
        0x95, 0xB5, 0x16, 0x0C, 0x37, 0xD8, 0xEA, 0x8A, 0xA0, 0x06,
        0x32, 0xBA, 0xB6, 0x73, 0x44, 0x32, 0x7E, 0x71, 0x09, 0xE2,
        0xDA, 0x8D, 0x7A, 0xEC, 0x26, 0xCE, 0x08, 0x91, 0x05, 0xAE,
        0x7E, 0xA7, 0x6C, 0xFF
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
